package org.beangle.webapp.portal.action;

import java.sql.Date;
import java.util.List;

import org.apache.struts2.ServletActionContext;
import org.apache.struts2.interceptor.NoParameters;
import org.beangle.model.query.builder.OqlBuilder;
import org.beangle.security.User;
import org.beangle.security.UserCategory;
import org.beangle.security.monitor.Authentication;
import org.beangle.security.monitor.AuthenticationException;
import org.beangle.security.monitor.SecurityManager;
import org.beangle.security.menu.MenuProfile;
import org.beangle.security.menu.service.MenuAuthorityService;
import org.beangle.struts2.action.BaseAction;

import com.opensymphony.xwork2.ActionContext;

/**
 * 加载用户登陆信息
 * 
 * @author duyaming
 * @author chaostone
 * 
 */
public class HomeAction extends BaseAction implements NoParameters {

	private MenuAuthorityService menuAuthorityService;

	protected SecurityManager securityManager;

	private User getUser() {
		Long userId = (Long) ActionContext.getContext().getSession().get(Authentication.USERID);
		if (null == userId)
			throw new AuthenticationException();
		else
			return (User) entityService.get(User.class, userId);
	}

	public String index() {
		User user = getUser();
		Long categoryId = getLong(Authentication.USER_CATEGORYID);
		Long curCategoryId = (Long) ActionContext.getContext().getSession().get(
				Authentication.USER_CATEGORYID);
		if (null == categoryId) {
			categoryId = curCategoryId;
		}
		if (!categoryId.equals(curCategoryId)) {
			UserCategory category = (UserCategory) entityService
					.get(UserCategory.class, categoryId);
			securityManager.getAuthenticationManager().getSessionController().changeCategory(
					ServletActionContext.getRequest().getSession().getId(), category);
			ActionContext.getContext().getSession().put(Authentication.USER_CATEGORYID, categoryId);
		}
		put("menus", menuAuthorityService.getMenus(getMenuProfile(categoryId), user, 1, ""));
		put("user", user);
		put("categories", user.getCategories());
		return forward();
	}

	/**
	 * 加载特定模块下的所有子模块
	 * 
	 * @param mapping
	 * @param form
	 * @param request
	 * @param response
	 * @return
	 */
	public String moduleList() {
		Long curCategory = (Long) ActionContext.getContext().getSession().get(
				Authentication.USER_CATEGORYID);
		List<?> modulesTree = menuAuthorityService.getMenus(getMenuProfile(curCategory), getUser(),
				-1, get("parentCode"));
		put("moduleTree", modulesTree);
		return forward();
	}

	public String welcome() {
		put("date", new Date(System.currentTimeMillis()));
		return forward();
	}

	protected MenuProfile getMenuProfile(Long categoryId) {
		OqlBuilder<MenuProfile> query = OqlBuilder.from(MenuProfile.class, "mp");
		query.where("category.id=:categoryId", categoryId).cacheable();
		List<MenuProfile> mps = entityService.search(query);
		if (mps.isEmpty()) {
			return null;
		} else {
			return mps.get(0);
		}
	}

	public void setMenuAuthorityService(MenuAuthorityService menuAuthorityService) {
		this.menuAuthorityService = menuAuthorityService;
	}

	public void setSecurityManager(SecurityManager securityManager) {
		this.securityManager = securityManager;
	}

}
